unit hiGL_ReadPixels;

interface

uses Kol,Share,Debug,OpenGL;

type
   THIGL_ReadPixels = class(TDebug)
   private
   Viewport : Array [0..3] of Integer;
   ProjMatrix: Array [0..15] of GLDouble;
   mvMatrix: Array [0..15] of GLDouble;
   RealY : GLint ;
   pixelColor : GLInt;
   pixelDepth : GLfloat;

   public
   _data_X:THI_Event;
   _data_Y:THI_Event;

   _event_onReadPixelsColor:THI_Event;
   _event_onReadPixelsDepth:THI_Event;

procedure _work_doReadPixelsColor(var _Data:TData; Index:word);
procedure _work_doReadPixelsDepth(var _Data:TData; Index:word);
procedure _var_PixelsColor(var _Data:TData; Index:word);
procedure _var_PixelsDepth(var _Data:TData; Index:word);
end;

implementation


procedure THIGL_ReadPixels._work_doReadPixelsColor;
var
   Yr:Integer;
   Xr:Integer;
begin
   Xr := ToIntegerEvent(_data_X);
   Yr := ToIntegerEvent(_data_Y);
   glGetIntegerv(GL_VIEWPORT, @Viewport);
   RealY := viewport[3] - Yr - 1;
   glReadPixels(Xr, RealY, 1, 1, GL_RGB, GL_UNSIGNED_BYTE, @pixelColor);
   _hi_onEvent(_event_onReadPixelsColor, pixelColor);
end;

procedure THIGL_ReadPixels._work_doReadPixelsDepth;
var
   Yr:Integer;
   Xr:Integer;
begin
   Xr := ToIntegerEvent(_data_X);
   Yr := ToIntegerEvent(_data_Y);
   glGetIntegerv(GL_VIEWPORT, @Viewport);
   RealY := viewport[3] - Yr - 1;
   glReadPixels(Xr, RealY, 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, @pixelDepth);
   _hi_onEvent(_event_onReadPixelsDepth, pixelDepth);
end;

procedure THIGL_ReadPixels._var_PixelsColor;
begin
   dtInteger(_Data, pixelColor);
end;

procedure THIGL_ReadPixels._var_PixelsDepth;
begin
   dtReal(_Data, pixelDepth);
end;

end.

